/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package cin.aquario;

import org.simulare.*;

/**
 * An action to execute corals and fishes movement into the aquarium.
 */
public class ActionMove extends AbstractTask {
    public static final String PRODUCERX = "altura";
    public static final String PRODUCERY = "largura";
    public static final String PRODUCERZ = "comprimento";

    public static final String CONSUMERX = "x";
    public static final String CONSUMERY = "y";
    public static final String CONSUMERZ = "z";

    public ActionMove() {
        this("move");
    }

    public ActionMove(String name) {
        super(name);
    }

    public void execute(Item item) {
        Attribute att = item.getAttribute(LivingThing.IS_ALIVE);
        if( att != null && att.getBoolean() ) {
            System.out.println(item.getName() + ":Start Moving");
            CompositeItem parent = item.getParent();

            Attribute px = parent.getAttribute(PRODUCERX);
            Attribute py = parent.getAttribute(PRODUCERY);
            Attribute pz = parent.getAttribute(PRODUCERZ);

            Attribute cx = item.getAttribute(CONSUMERX);
            Attribute cy = item.getAttribute(CONSUMERY);
            Attribute cz = item.getAttribute(CONSUMERZ);

            System.out.println("Nome do Elemento: " + item.getName());

            if (item.getName().startsWith("coral")) {

                // Gera um randomico entre 1 e 2, se for 1 anda no eixo x e se for 2 anda no eixo z.
                int rand = 1 + (int) (Math.random() * 2);
                // decide se incrementa (1) ou decrementa (2).
                int mov = 1 + (int) (Math.random() * 2);

                // eixo x
                if (rand == 1) {

                    if ((mov == 1) && (cx.getInt() < px.getInt())) {
                        System.out.println("a: " + mov + "  " + cx.getInt() +
                                           "  " +
                                           px.getInt());
                        cx.setValue(new Integer(cx.getInt() + 1));
                    } else if ((mov == 1) && (cx.getInt() >= px.getInt())) {
                        System.out.println("b: " + mov + "  " + cx.getInt() +
                                           "  " +
                                           px.getInt());
                        cx.setValue(new Integer(cx.getInt() - 1));
                    }

                    if ((mov == 2) && (cx.getInt() > -px.getInt())) {
                        System.out.println("c: " + mov + "  " + cx.getInt() +
                                           "  " +
                                           px.getInt());
                        cx.setValue(new Integer(cx.getInt() - 1));
                    } else if ((mov == 2) && (cx.getInt() == -px.getInt())) {
                        System.out.println("d: " + mov + "  " + cx.getInt() +
                                           "  " +
                                           px.getInt());
                        cx.setValue(new Integer(cx.getInt() + 1));
                    }
                }

                // eixo z
                if (rand == 2) {
                    if ((mov == 1) && (cz.getInt() < pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() + 1));
                    } else if ((mov == 1) && (cz.getInt() >= pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() - 1));
                    }

                    if ((mov == 2) && (cz.getInt() > -pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() - 1));
                    } else if ((mov == 2) && (cz.getInt() == -pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() + 1));
                    }
                }

                System.out.println("Consumer-c x: " + cx.getInt());
                System.out.println("Consumer-c y: " + cy.getInt());
                System.out.println("Consumer-c z: " + cz.getInt());

            }
            if ((item.getName().startsWith("presa")) ||
                (item.getName().startsWith("predador"))) {

                // Gera um randomico entre 1, 2 e 3, se for 1 anda no eixo x e se for 2 anda no eixo y e 3 no eixo z
                int rand = 1 + (int) (Math.random() * 3);
                // decide se incrementa ou decrementa.
                int mov = 1 + (int) (Math.random() * 2);

                // eixo x
                if (rand == 1) {
                    if ((mov == 1) && (cx.getInt() < px.getInt())) {
                        cx.setValue(new Integer(cx.getInt() + 1));
                    } else if ((mov == 1) && (cx.getInt() >= px.getInt())) {
                        cx.setValue(new Integer(cx.getInt() - 1));
                    }

                    if ((mov == 2) && (cx.getInt() > -px.getInt())) {
                        cx.setValue(new Integer(cx.getInt() - 1));
                    } else if ((mov == 2) && (cx.getInt() == -px.getInt())) {
                        cx.setValue(new Integer(cx.getInt() + 1));
                    }

                }

                // eixo y
                if (rand == 2) {
                    if ((mov == 1) && (cy.getInt() < py.getInt())) {
                        cy.setValue(new Integer(cy.getInt() + 1));
                    } else if ((mov == 1) && (cy.getInt() >= py.getInt())) {
                        cy.setValue(new Integer(cy.getInt() - 1));
                    }

                    if ((mov == 2) && (cy.getInt() > -py.getInt())) {
                        cy.setValue(new Integer(cy.getInt() - 1));
                    } else if ((mov == 2) && (cy.getInt() == -py.getInt())) {
                        cy.setValue(new Integer(cy.getInt() + 1));
                    }

                }

                // eixo z
                if (rand == 3) {
                    if ((mov == 1) && (cz.getInt() < pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() + 1));
                    } else if ((mov == 1) && (cz.getInt() >= pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() - 1));
                    }

                    if ((mov == 2) && (cz.getInt() > -pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() - 1));
                    } else if ((mov == 2) && (cz.getInt() == -pz.getInt())) {
                        cz.setValue(new Integer(cz.getInt() + 1));
                    }
                }

                System.out.println("Consumer-p x: " + cx.getInt());
                System.out.println("Consumer-p y: " + cy.getInt());
                System.out.println("Consumer-p z: " + cz.getInt());

            }
            fireTask(item);
            System.out.println(item.getName() + ":End Moving");
        }

    }

}