/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package cin.aquario;

import org.simulare.*;

/**
 * The items structure which represents an aquarium, with only one coral, one
 * fish and one predator.
 */
public class Example {

    public static CompositeItem aquario;
    public static Item coral;
    public static Item presa;
    public static Item predador;

    static {
        aquario = new CompositeItem("aquario");
        aquario.addAttribute(new Attribute(ActionBreath.PRODUCER, Integer.class, null));
        aquario.addAttribute(new Attribute(ActionMove.PRODUCERX, Double.class,
                                           new Double(2)));
        aquario.addAttribute(new Attribute(ActionMove.PRODUCERY, Double.class,
                                           new Double(3)));
        aquario.addAttribute(new Attribute(ActionMove.PRODUCERZ, Double.class,
                                           new Double(4)));

        coral = new Item("coral");
        coral.addAttribute(new Attribute(ActionBreath.CONSUMER, Integer.class, null));
        coral.addAttribute(new Attribute(ActionMove.CONSUMERX, Double.class,
                                         new Double(1)));
        coral.addAttribute(new Attribute(ActionMove.CONSUMERY, Double.class,
                                         new Double( -3)));
        coral.addAttribute(new Attribute(ActionMove.CONSUMERZ, Double.class,
                                         new Double(1)));
        coral.addAttribute(new Attribute(LivingThing.IS_ALIVE, Boolean.class,
                                         Boolean.TRUE));
        aquario.addItem(coral);

        presa = new Item("presa");
        presa.addAttribute(new Attribute(ActionBreath.CONSUMER, Integer.class, null));
        presa.addAttribute(new Attribute(ActionMove.CONSUMERX, Double.class,
                                         new Double(1)));
        presa.addAttribute(new Attribute(ActionMove.CONSUMERY, Double.class,
                                         new Double(1)));
        presa.addAttribute(new Attribute(ActionMove.CONSUMERZ, Double.class,
                                         new Double(0)));
        presa.addAttribute(new Attribute(LivingThing.IS_ALIVE, Boolean.class,
                                         Boolean.TRUE));
        aquario.addItem(presa);

        predador = new Item("predador");
        predador.addAttribute(new Attribute(ActionBreath.CONSUMER, Integer.class, null));
        predador.addAttribute(new Attribute(ActionMove.CONSUMERX, Double.class,
                                            new Double(0)));
        predador.addAttribute(new Attribute(ActionMove.CONSUMERY, Double.class,
                                            new Double(1)));
        predador.addAttribute(new Attribute(ActionMove.CONSUMERZ, Double.class,
                                            new Double(1)));
        predador.addAttribute(new Attribute(LivingThing.IS_ALIVE, Boolean.class,
                                         Boolean.TRUE));
        aquario.addItem(predador);
    }
}