/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package cin.aquario;

import org.simulare.*;

/**
 * A report which print item on System.out.
 */
public class ReportPrintln extends AbstractTask {

    private String gap = "";
    private String block = "    ";

    public ReportPrintln() {
        this("report_out");
    }

    public ReportPrintln(String name) {
        super(name);
    }

    public void execute(Item item) {
        System.out.println(gap + "Item:" + item.getName());
        for (int i = 0; i < item.getAttributesLength(); i++) {
            Attribute att = item.getAttribute(i);
            System.out.println(gap + "  Attribute:" + att.getName() + "," +
                               att.getValue());
        }
        if (item instanceof CompositeItem) {
            CompositeItem ci = (CompositeItem) item;
            gap += block;
            for (int i = 0; i < ci.getItemsLength(); i++) {
                execute(ci.getItem(i));
            }
            gap = gap.substring(block.length());
        }
    }
}