package cin.aquario;

import org.simulare.*;


public class SetupBoolean extends AbstractTask {

    private boolean value;
    private String attribute;

    public SetupBoolean() {
        this(null,true);
    }

    public SetupBoolean(String attribute, boolean value) {
        super("boolean");
        setAttribute(attribute);
        setValue(value);
    }

    public String getAttribute() {
        return attribute;
    }

    public void setAttribute(String attribute) {
        this.attribute = attribute;
    }

    public boolean isValue() {
        return value;
    }

    public void setValue(boolean value) {
        this.value = value;
    }

    public void execute(Item item) {
        Attribute att = item.getAttribute(attribute);
        if (att != null) {
            if (att.getType() == Boolean.class) {
                att.setValue(value ? Boolean.TRUE : Boolean.FALSE);
            }
            System.out.println(item + "." + att + " set to " + att.getValue());
        }
    }
}