/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package cin.aquario;

import java.awt.*;

import javax.media.j3d.*;

import com.sun.j3d.utils.universe.*;

/**
 * Create a 3D world to be used in 3D reports.
 */
public class UniverseBuilder {

    public static SimpleUniverse getUniverse() {
        GraphicsEnvironment environment = GraphicsEnvironment.
                                          getLocalGraphicsEnvironment();
        GraphicsDevice device = environment.getDefaultScreenDevice();
        GraphicsConfigTemplate3D template = new GraphicsConfigTemplate3D();
        GraphicsConfiguration configuration = device.getBestConfiguration(
                template);
        Canvas3D canvas = new Canvas3D(configuration);
        SimpleUniverse universe = new SimpleUniverse(canvas);
        ViewingPlatform viewingPlataform = universe.getViewingPlatform();
        viewingPlataform.setNominalViewingTransform();
        return universe;
    }

}
