/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package org.simulare;


/**
 * An item formed by another itens which has a tree structure.
 */
public class CompositeItem extends CollectionItem {

    public CompositeItem(String name) {
        super(name);
    }

    public void addItem(int index, Item item) {
        super.addItem(index, item);
        //set parent after event
        if (item != null) {
            item.setParent(this);
        }
    }

    public Item removeItem(String name) {
        Item result = super.removeItem(name);
        //set parent after event
        if (result != null) {
            result.setParent(null);
        }
        return result;
    }
}
