/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package org.simulare.gui;

import java.awt.event.*;
import java.util.*;

import javax.swing.*;

/**
 * The popup shown right buttom is pressed on tree.
 */
public class CompositeItemPopup extends JPopupMenu {
    JMenuItem jMenuItemAdd = new JMenuItem();
    JMenuItem jMenuItemRemove = new JMenuItem();
    JMenu jMenu1 = new JMenu();
    JMenuItem jMenuItemExpandCurrent = new JMenuItem();
    JMenuItem jMenuItemExpandAll = new JMenuItem();
    JMenu jMenu2 = new JMenu();
    JMenuItem jMenuItemColapseCurrent = new JMenuItem();
    JMenuItem jMenuItemColapseAll = new JMenuItem();
    private transient Vector actionListeners;
    public CompositeItemPopup() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        jMenuItemAdd.setText("Add Item");
        jMenuItemAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemAdd_actionPerformed(e);
            }
        });
        jMenuItemRemove.setText("Remove Item");
        jMenuItemRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemRemove_actionPerformed(e);
            }
        });
        jMenu1.setText("Expand");
        jMenuItemExpandCurrent.setActionCommand("Expand Current");
        jMenuItemExpandCurrent.setText("Current");
        jMenuItemExpandCurrent.addActionListener(new java.awt.event.
                                                 ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemExpandCurrent_actionPerformed(e);
            }
        });
        jMenuItemExpandAll.setActionCommand("Expand All");
        jMenuItemExpandAll.setText("All");
        jMenuItemExpandAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemExpandAll_actionPerformed(e);
            }
        });
        jMenu2.setText("Colapse");
        jMenuItemColapseCurrent.setActionCommand("Colapse Current");
        jMenuItemColapseCurrent.setText("Current");
        jMenuItemColapseCurrent.addActionListener(new java.awt.event.
                                                  ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemColapseCurrent_actionPerformed(e);
            }
        });
        jMenuItemColapseAll.setActionCommand("Colapse All");
        jMenuItemColapseAll.setText("All");
        jMenuItemColapseAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItemColapseAll_actionPerformed(e);
            }
        });
        this.add(jMenu1);
        this.addSeparator();
        this.add(jMenu2);
        this.addSeparator();
        this.add(jMenuItemAdd);
        this.add(jMenuItemRemove);
        jMenu1.add(jMenuItemExpandCurrent);
        jMenu1.add(jMenuItemExpandAll);
        jMenu2.add(jMenuItemColapseCurrent);
        jMenu2.add(jMenuItemColapseAll);
    }

    public synchronized void removeActionListener(ActionListener l) {
        if (actionListeners != null && actionListeners.contains(l)) {
            Vector v = (Vector) actionListeners.clone();
            v.removeElement(l);
            actionListeners = v;
        }
    }

    public synchronized void addActionListener(ActionListener l) {
        Vector v = actionListeners == null ? new Vector(2) :
                   (Vector) actionListeners.clone();
        if (!v.contains(l)) {
            v.addElement(l);
            actionListeners = v;
        }
    }

    protected void fireActionPerformed(ActionEvent e) {
        if (actionListeners != null) {
            Vector listeners = actionListeners;
            int count = listeners.size();
            for (int i = 0; i < count; i++) {
                ((ActionListener) listeners.elementAt(i)).actionPerformed(e);
            }
        }
    }

    void jMenuItemExpandCurrent_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }

    void jMenuItemExpandAll_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }

    void jMenuItemColapseCurrent_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }

    void jMenuItemColapseAll_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }

    void jMenuItemAdd_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }

    void jMenuItemRemove_actionPerformed(ActionEvent e) {
        fireActionPerformed(e);
    }
}