/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package org.simulare.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import org.simulare.*;

/**
 * The application frame.
 */
public class FrameSimulare extends JFrame {
    JPanel contentPane;
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileExit = new JMenuItem();
    JMenu jMenuHelp = new JMenu();
    JMenuItem jMenuHelpAbout = new JMenuItem();
    JToolBar jToolBar = new JToolBar();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image3;
    JLabel statusBar = new JLabel();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    CompositeItemPanel jPanelComposite = new CompositeItemPanel();
    JTabbedPane jPanelTypes = new JTabbedPane();
    JPanel jPanelInstances = new JPanel();
    JPanel jPanelVisualization = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JSplitPane jSplitPane1 = new JSplitPane();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel3D = null;
    BorderLayout borderLayout5 = new BorderLayout();
    JScrollPane jScrollPane2 = new JScrollPane();
    JList jList1 = new JList();
    JPanel jPanel5 = new JPanel();
    ClockPanel jPanelClock = new ClockPanel();
    FlowLayout flowLayout1 = new FlowLayout();

    //Construct the frame
    public FrameSimulare() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            Simulation sim = cin.aquario.SimulationAquario.sim;
            jPanelClock.setClock(sim.getClock());
            jPanel3D = (JPanel) cin.aquario.SimulationAquario.view.getView();
            jbInit();
            jPanelTypes.setSelectedComponent(jPanelVisualization);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Component initialization
    private void jbInit() throws Exception {
        image1 = new ImageIcon(org.simulare.gui.FrameSimulare.class.getResource(
                "Open16.gif"));
        image2 = new ImageIcon(org.simulare.gui.FrameSimulare.class.getResource(
                "closeFile.png"));
        image3 = new ImageIcon(org.simulare.gui.FrameSimulare.class.getResource(
                "Help16.gif"));
        contentPane = (JPanel)this.getContentPane();
        contentPane.setLayout(borderLayout1);
        this.setJMenuBar(jMenuBar1);
        this.setSize(new Dimension(573, 450));
        this.setTitle("Simulare - An Open Tool for Simulation");
        statusBar.setText(" ");
        jMenuFile.setText("File");
        jMenuFileExit.setText("Exit");
        jMenuFileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuFileExit_actionPerformed(e);
            }
        });
        jMenuHelp.setText("Help");
        jMenuHelpAbout.setText("About");
        jMenuHelpAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuHelpAbout_actionPerformed(e);
            }
        });
        jButton1.setIcon(image1);
        jButton1.setToolTipText("Open File");
        jButton2.setIcon(image2);
        jButton2.setToolTipText("Close File");
        jButton3.setIcon(image3);
        jButton3.setToolTipText("Help");
        jPanel1.setLayout(borderLayout2);
        borderLayout2.setHgap(5);
        borderLayout2.setVgap(5);
        jPanelVisualization.setLayout(borderLayout3);
        jSplitPane1.setOneTouchExpandable(true);
        jPanel3.setLayout(borderLayout4);
        jPanel3D.setBackground(new Color(140, 182, 107));
        jPanel3D.setMinimumSize(new Dimension(10, 10));
        jScrollPane1.setBorder(new TitledBorder(BorderFactory.
                                                createEtchedBorder(Color.white,
                new Color(142, 142, 142)), "Graphic Model:"));
        jPanel4.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(
                Color.white, new Color(142, 142, 142)), "Other reports:"));
        jPanel4.setLayout(borderLayout5);
        jPanel5.setLayout(flowLayout1);
        flowLayout1.setAlignment(FlowLayout.RIGHT);
        flowLayout1.setHgap(0);
        flowLayout1.setVgap(0);
        jToolBar.add(jButton1);
        jToolBar.add(jButton2);
        jToolBar.add(jButton3);
        jMenuFile.add(jMenuFileExit);
        jMenuHelp.add(jMenuHelpAbout);
        jMenuBar1.add(jMenuFile);
        jMenuBar1.add(jMenuHelp);
        contentPane.add(jToolBar, BorderLayout.NORTH);
        contentPane.add(statusBar, BorderLayout.SOUTH);
        contentPane.add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jPanelTypes, BorderLayout.CENTER);
        jPanelTypes.add(jPanelComposite, "Types");
        jPanelTypes.add(jPanelInstances, "Instances");
        jPanelTypes.add(jPanelVisualization, "Visualization");
        jPanelVisualization.add(jSplitPane1, BorderLayout.CENTER);
        jSplitPane1.add(jPanel3, JSplitPane.LEFT);
        jPanel3.add(jScrollPane1, BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jPanel3D, null);
        jSplitPane1.add(jPanel4, JSplitPane.RIGHT);
        jPanel4.add(jScrollPane2, BorderLayout.CENTER);
        jScrollPane2.getViewport().add(jList1, null);
        jPanel1.add(jPanel5, BorderLayout.SOUTH);
        jPanel5.add(jPanelClock, null);
        jSplitPane1.setDividerLocation(200);
        jPanelComposite.setDividerLocation(200);
    }

    //File | Exit action performed
    public void jMenuFileExit_actionPerformed(ActionEvent e) {
        System.exit(0);
    }

    //Help | About action performed
    public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
        FrameSimulare_AboutBox dlg = new FrameSimulare_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x,
                        (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.pack();
        dlg.show();
    }

    //Overridden so we can exit when window is closed
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            jMenuFileExit_actionPerformed(null);
        }
    }

    void jButtonParameter_actionPerformed(ActionEvent e) {
        jPanelTypes.setSelectedComponent(jPanelComposite);
    }
}