/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package org.simulare.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import org.simulare.*;
import java.util.*;

/**
 * The graphica representation of a simulation item.
 */
public class ItemPanel extends JPanel {
    JScrollPane jScrollPane1 = new JScrollPane();
    JTable jTableAttributes = new JTable();
    JPanel jPanel1 = new JPanel();
    JLabel jLabelName = new JLabel();
    JTextField jTextFieldName = new JTextField();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel2 = new JPanel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    ItemTableModel model;
    BorderLayout borderLayout1 = new BorderLayout();
    ImageIcon add16, remove16, up16, down16;
    private Item item;
    Control jPanelControl = new Control();
    private transient Vector actionListeners;
    public ItemPanel(Item item) {
        try {
            jbInit();
            this.item = item;
            model = new ItemTableModel(item);
            jTableAttributes.setModel(model);
            jTableAttributes.setDefaultEditor(Type.class,
                                              new ItemTableEditor(new JComboBox()));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        add16 = new ImageIcon(org.simulare.gui.ItemPanel.class.getResource(
                "New16.gif"));
        remove16 = new ImageIcon(org.simulare.gui.ItemPanel.class.getResource(
                "Remove16.gif"));
        up16 = new ImageIcon(org.simulare.gui.ItemPanel.class.getResource(
                "Up16.gif"));
        down16 = new ImageIcon(org.simulare.gui.ItemPanel.class.getResource(
                "Down16.gif"));

        this.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.
                white, new Color(148, 145, 140)), "Item:"));
        this.setLayout(borderLayout1);
        jLabelName.setText("Name:");
        jPanel1.setLayout(borderLayout2);
        jTextFieldName.setText("");
    jTextFieldName.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        jTextFieldName_focusLost(e);
      }
    });
        jTextFieldName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jTextFieldName_actionPerformed(e);
            }
        });
        jPanel2.setLayout(gridBagLayout1);
        jScrollPane1.setBorder(new TitledBorder(BorderFactory.
                                                createEtchedBorder(Color.white,
                new Color(142, 142, 142)), "Attributes:"));
        borderLayout2.setHgap(2);
        borderLayout2.setVgap(0);
        jPanelControl.addControlListener(new org.simulare.gui.ControlListener() {
            public void addClicked(ControlEvent e) {
                jPanelControl_addClicked(e);
            }

            public void removeClicked(ControlEvent e) {
                jPanelControl_removeClicked(e);
            }

            public void upClicked(ControlEvent e) {
                jPanelControl_upClicked(e);
            }

            public void downClicked(ControlEvent e) {
                jPanelControl_downClicked(e);
            }
        });
        jPanel1.add(jLabelName, BorderLayout.WEST);
        jPanel1.add(jTextFieldName, BorderLayout.CENTER);
        this.add(jScrollPane1, BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jTableAttributes, null);
        this.add(jPanel1, BorderLayout.NORTH);
        this.add(jPanel2, BorderLayout.EAST);
        jPanel2.add(jPanelControl, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
    }


    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        jTextFieldName.setText(item.getName());
        model.setItem(item);
        this.item = item;
    }

    void jTextFieldName_focusLost(FocusEvent e) {
        changeName(new ActionEvent(e.getSource(),ActionEvent.ACTION_PERFORMED,"nameChanged"));
    }

    void jTextFieldName_actionPerformed(ActionEvent e) {
        changeName(e);
    }

    private void changeName(ActionEvent e) {
        item.setName(jTextFieldName.getText());
        fireActionPerformed(e);
    }

    void jPanelControl_addClicked(ControlEvent e) {
        model.add(jTableAttributes.getSelectedRow());
        fireActionPerformed(e.action);
    }

    void jPanelControl_removeClicked(ControlEvent e) {
        model.remove(jTableAttributes.getSelectedRow());
        fireActionPerformed(e.action);
    }

    void jPanelControl_upClicked(ControlEvent e) {
        model.up(jTableAttributes.getSelectedRow());
        fireActionPerformed(e.action);
    }

    void jPanelControl_downClicked(ControlEvent e) {
        model.down(jTableAttributes.getSelectedRow());
        fireActionPerformed(e.action);
    }

    public synchronized void removeActionListener(ActionListener l) {
        if (actionListeners != null && actionListeners.contains(l)) {
            Vector v = (Vector) actionListeners.clone();
            v.removeElement(l);
            actionListeners = v;
        }
    }

    public synchronized void addActionListener(ActionListener l) {
        Vector v = actionListeners == null ? new Vector(2) :
                   (Vector) actionListeners.clone();
        if (!v.contains(l)) {
            v.addElement(l);
            actionListeners = v;
        }
    }

    protected void fireActionPerformed(ActionEvent e) {
        if (actionListeners != null) {
            Vector listeners = actionListeners;
            int count = listeners.size();
            for (int i = 0; i < count; i++) {
                ((ActionListener) listeners.elementAt(i)).actionPerformed(e);
            }
        }
    }
}