/*
 * Simulare is the legal property of USINA (http://usina.tigris.org),
 * and all those who contributed to the development of this tool. Please
 * refer to the COPYRIGHT file distributed with this source distribution
 * for a list of contributors.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or(at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package org.simulare.gui;

/**
 * Enumerate the allowed types for attributes.
 */
public class Type {
    public String name;
    public Class type;

    public static Type BOO = new Type("boolean", Boolean.class);
    public static Type CHA = new Type("char", Character.class);
    public static Type BYT = new Type("byte", Byte.class);
    public static Type SHO = new Type("short", Short.class);
    public static Type INT = new Type("int", Integer.class);
    public static Type LON = new Type("long", Long.class);
    public static Type FLO = new Type("float", Float.class);
    public static Type DOU = new Type("double", Double.class);
    public static Type STR = new Type("String", String.class);

    public static Type[] types = new Type[] {BOO, CHA, BYT, SHO, INT, LON, FLO,
                                 DOU, STR};

    public static String getName(Class type) {
        if (type == Boolean.class) {
            return BOO.name;
        } else if (type == Character.class) {
            return CHA.name;
        } else if (type == Byte.class) {
            return BYT.name;
        } else if (type == Short.class) {
            return SHO.name;
        } else if (type == Integer.class) {
            return INT.name;
        } else if (type == Long.class) {
            return LON.name;
        } else if (type == Float.class) {
            return FLO.name;
        } else if (type == Double.class) {
            return DOU.name;
        } else if (type == String.class) {
            return STR.name;
        }
        return null;
    }

    public static Class getType(String name) {
        if ("boolean".equals(name)) {
            return BOO.type;
        } else if ("char".equals(name)) {
            return CHA.type;
        } else if ("byte".equals(name)) {
            return BYT.type;
        } else if ("short".equals(name)) {
            return SHO.type;
        } else if ("int".equals(name)) {
            return INT.type;
        } else if ("long".equals(name)) {
            return LON.type;
        } else if ("float".equals(name)) {
            return FLO.type;
        } else if ("double".equals(name)) {
            return DOU.type;
        } else if ("String".equals(name)) {
            return STR.type;
        }
        return null;
    }

    private Type(String name, Class type) {
        this.name = name;
        this.type = type;
    }

    public String toString() {
        return name;
    }
}